 {Typy danych wykorzystywane w procedurze Dijkstra}
const n=50;
type
 Arrn    =array[1..n] of integer;
 BoolArrn=array[1..n] of Boolean;
 Arrnn   =array[1..n,1..n] of integer;


procedure Dijkstra(n,Inf,s,t:integer; w:Arrnn; var Path:Boolean;
                   var Final:BoolArrn; var Dist,Pred:Arrn);
  {Procedura znajduje najkrotsze drogi w n wierzcholkowej sieci
   z wierzcholka s do wierzcholka t lub do wszystkich pozostalych
   wierzcholkow w sieci. Moze byc wykorzystana do znajdowania
   najkrotszej drogi prowadzacej do wyjscia w labiryncie, zob.
   p. 11.1.3. Dokladny opis algorytmu Dijkstry oraz tej procedury
   znajduje sie w [Syslo].}
 var u,v,y,Recent,NewLabel,Temp:integer;
begin
 for v:=1 to n do begin     {Ustalenie wartosci poczatkowych.}
  Dist[v]:=Inf;  Final[v]:=false;  Pred[v]:=-1
 end;
 Dist[s]:=0;  Final[s]:=true;
 Path:=true;  Recent:=s;
 while not Final[t] do begin
  for v:=1 to n do          {Poprawianie odleglosci.}
   if (w[Recent,v]<Inf) and (not Final[v]) then begin
    NewLabel:=Dist[Recent]+w[Recent,v];
    if NewLabel<Dist[v] then begin
     Dist[v]:=NewLabel;  Pred[v]:=Recent
    end
   end;
  Temp:=Inf;                {Znajdowanie najblizszego wierzcholka.}
  for u:=1 to n do
   if (not Final[u]) and (Dist[u]<Temp) then begin
    y:=u;  Temp:=Dist[u]
   end;
  if Temp<Inf then begin
   Final[y]:=true;  Recent:=y
  end
  else begin
   Path:=false;  Final[t]:=true
  end
 end  {while not Final[t] }
end; {Dijkstra}

begin
end.
